/* © 2017 Playful Invention Company */

const {ipcRenderer, remote} = require('electron');  
const main = remote.require("./main.js");


Maker = function() {};
Maker.blocks = [];
Maker.files;
Maker.loadCount;
Maker.loadn = 0;
Maker.timeout=undefined;
Maker.width=920;
Maker.height=736;
Maker.time;

Maker.mode = undefined;
Maker.modes = {
	normal: {},
	outside: {pensize: 0.001, fill: 'none', stroke: "#FF0000"},
	stroke: {pensize: 0.001, fill: 'none', stroke: "#FF0000"},
	outline: {pensize: 0.001, fill: 'none', stroke: "#FF0000"}
	
}

Maker.setProcessState = function (type){
	console.log ("setProcessState", type, Maker.modes [type]);
	Maker.mode = Maker.modes [type] ? type : undefined;
}

Maker.startup = function(){
	libInit();
	var mode = main.getUserPreference("processMode");
	Maker.setProcessState(mode);
	window[eventDispatch["start"]]= function(e){Maker.unfocus();};
	gn("frame").ondragover = Maker.allowDrop;
	gn("frame").ondrop = Maker.handleDropFile;
	Defs.defineBlocks();
	Turtle.setup();
	Maker.ctx = cnv.getContext('2d');
}

Maker.allowDrop = function(evt) { 
	evt.preventDefault(); 
	evt.stopPropagation();
}

Maker.handleDropFile = function(evt) { 
	evt.preventDefault(); 
	if (evt.stopPropagation) evt.stopPropagation();
	else evt.cancelBubble = true;
	Maker.files = getFileNames(evt.dataTransfer.files);
	Maker.loadCount = Maker.files.length;
	if (Maker.loadCount > 0){
		while (gn("stripcontents").childElementCount > 0) gn("stripcontents").removeChild(gn("stripcontents").childNodes[0]);	
	}
	Maker.unfocus();
	Maker.loadn = 0;
	gn("loader").className = "loader on";
	Maker.loadNext();
	
	function getFileNames (files) {
		var res = [];
		for (var i = 0; i < files.length; i++){
			res.push (files[i].path);
		}
		return res;
	}
}

Maker.convertToSVG = function(name) {
	Maker.files = [name]
	Maker.loadCount = Maker.files.length;
	Maker.loadn = 0;
	Maker.loadNext();
}

Maker.unfocus = function (){
		if (!Maker.alert) return;
		Maker.alert.parentNode.removeChild(Maker.alert);
		Maker.alert = undefined;
}

Maker.loadNext = function() { 
	Maker.time = new Date().getTime();
	console.log (" PNG.load " + Maker.files[Maker.loadn]);
	if (Maker.loadn < Maker.loadCount) {	
		PNG.load(Maker.files[Maker.loadn], cnv, Maker.loaded); 
	}
	else gn("loader").className = "loader off";
}

Maker.loaded = function(pngobj) {
	console.log ("loaded" + pngobj.error);
	if (pngobj.error){ 	
		var thumb =  newHTML ('div', 'stripimg', gn("stripcontents"));
		thumb.name = Maker.files[Maker.loadn];
		Maker.addAlert (pngobj.error);
		Maker.nextFile();
	}
	else Maker.stractInfo(pngobj);
}

Maker.stractInfo = function(pngobj) {
	var ctx = cnv.getContext('2d');
	var str = Img.getImageData(ctx);	
	Maker.addThumb(cnv);
	Maker.error = undefined;
//	console.log (str);
	if(str.indexOf('bad') < 0){
		Turtle.init();
		var data = Tokenizer.tokenize(str.substr(1,str.length-2));
		var records = data[0];
		Maker.restoreTurtle(data[3]);
		Maker.blocks = new Array();
		var canContinue = Maker.addBlocks(records);
		if (canContinue){
			Maker.connectBlocks(records);
			Maker.findProcs(Maker.blocks);
			Runtime.runStack(Maker.findStartingBlock());
			Maker.saveWhenDone();
		}
		else {
			Maker.addAlert (Maker.error);
			Maker.nextFile();
		}
	}
	else {
		Maker.addAlert (Maker.filename+ ".png is not a recognizable TurtleArt file");
		Maker.nextFile();
	}
}

Maker.addThumb = function (cnv){
	var dataUrl = cnv.toDataURL();
  var img =  new Image();
	img.src = dataUrl;	
	var thumb =  newHTML ('div', 'stripimg', gn("stripcontents"));
	var w = thumb.offsetWidth;
	if(!img.complete) img.onload =function(){display(img, thumb);}
  else display(img, thumb);
  function display(img, thumb) {
		var scale = w / img.naturalWidth;
		img.style.zoom = scale;
		thumb.name =  Maker.files[Maker.loadn];
		thumb.appendChild(img);
	}
}

Maker.saveWhenDone = function(){
	var cond = function(){return Runtime.isActive();};
	if (Maker.timeout != undefined) clearTimeout(Maker.timeout);
	Maker.timeout = setTimeout(function (){ waituntil (cond, doNext); }, 500);
	function doNext (){
		if (!Maker.error) Maker.save();
		else {
			Maker.addAlert(Maker.error);
			Maker.nextFile();
		}
	}
}

Maker.doneSaving  = function(){
	Maker.addOK();
	Maker.nextFile();
}

Maker.saveError = function(str){
	Maker.addAlert(str);
	Maker.nextFile();
}

Maker.nextFile = function (){
	Maker.loadn++;
	Maker.loadNext();
}  	

Maker.addAlert = function(msg){
	var p  = gn("stripcontents");
	var kid = p.childNodes[p.childElementCount - 1];
	var alert = newHTML('div', 'stripimgalert', kid);
	alert.id = "erroralert";
	alert.error = msg;
	alert[eventDispatch["start"]]=showAlert;
	
	function showAlert(e){
		if (Maker.alert) {closeAlert(e); return;}
		e.preventDefault();
		e.stopPropagation();
		var t = e.target;
		var alert = newHTML("div", "alertstyle", frame);
		Maker.alert = alert;
		var aarrow = newHTML("div", "alertarrow", alert);
		var p = newHTML("p",undefined, alert);
		p.textContent =  t.error;		
		setProps(alert.style, {height: (10+p.offsetHeight) + "px", top: (globaly(kid) - p.offsetHeight - 10) + "px", left: globalx(kid) + "px"}); 	
		setProps(aarrow.style, {top: (2 +p.offsetHeight) + "px", left: Math.floor((kid.offsetWidth - 18) / 2) +"px"}); 	
		alert[eventDispatch["start"]]=closeAlert;
		
	}
		
	function closeAlert(e){
		e.preventDefault();
		e.stopPropagation();
		Maker.unfocus();
	}
}

Maker.addOK = function(){
	var p  = gn("stripcontents");
	var kid = p.childNodes[p.childElementCount - 1];
	var alert = newHTML('div', 'stripimgOK', kid);
}

Maker.save = function(){
	var str = "";
	
	switch (Maker.mode){
		case "stroke": str = PathTool.getCutout(Maker.modes[Maker.mode],Turtle.svg); break;
		case "outline": str =  PathTool.getOutline(Maker.modes[Maker.mode], Turtle.svg, true); break;
		case "outside": str =  PathTool.getOutline(Maker.modes[Maker.mode], Turtle.svg, false); break;
		case "normal": str =  PathTool.takeOutBackground (Turtle.svg); break;
		default: str = PathTool.getOriginal(Turtle.svg); break;
	}
	var path = Maker.files[Maker.loadn];
	var name = path.split("/").pop();
	var msg =  name +" approximate size is " + (Math.floor(str.length / 100000) / 10 )+"MB. Do you still want to save it?";
	var filename = getName (path);
	if (str.length > 500000) Maker.openDialog (filename, str,msg);
	else main.saveProject(filename, str); 
	function getName (name) {return name.split(".")[0] +(Maker.mode ? Maker.mode : "")+".svg";}
}

Maker.openAlert = function (message){
	gn("alertmessage").textContent = message;
	gn("backdrop").setAttribute("class","modal-backdrop fade in");
	setProps(gn("backdrop").style, {display: 'block'});
	gn("Cancel").textContent = "";
	gn("Cancel").className = "buttonhidden";
	gn("alertdialog").setAttribute("class","alertdialog fade in");	
	gn("OK")[eventDispatch["start"]]= function (e) {Maker.skipFile(e);};
}

Maker.openDialog = function (name, svg, message){
	gn("alertmessage").textContent = message;
	gn("backdrop").setAttribute("class","modal-backdrop fade in");
	setProps(gn("backdrop").style, {display: 'block'});
	gn("Cancel").textContent = "Cancel";
	gn("Cancel").className = "button";
	gn("alertdialog").setAttribute("class","alertdialog fade in");	
	gn("OK")[eventDispatch["start"]]= function (e) {Maker.saveAnyway(e, name, svg);};
	gn("Cancel")[eventDispatch["start"]]= function (e) {Maker.skipSave(e, name, svg);};
}

Maker.skipSave = function (e, name, svg){
	e.preventDefault();
	e.stopPropagation();
	var str = name+ " approximate file size would have been " +  Math.floor(svg.length / 1000000)+"MB. You chose not to save it.";
	Maker.addAlert(str);
	Maker.closeDialog();
	Maker.nextFile();
}

Maker.saveAnyway = function (e, name, str){
	e.preventDefault();
	e.stopPropagation();
	Maker.closeDialog();
	main.saveProject(name, str, Maker.doneSaving);
}

Maker.closeDialog = function (){
	gn("backdrop").setAttribute("class","modal-backdrop fade out");
	setProps(gn("backdrop").style, {display: 'none'});
	gn("alertdialog").setAttribute("class","alertdialog fade out");	
}

Maker.skipFile = function (e){
	e.preventDefault();
	e.stopPropagation();
	Maker.closeDialog();
	Maker.nextFile();
}


Maker.restoreTurtle = function(r){
	if (!r) return;
	Turtle.xcor=r[0];
	Turtle.ycor= r[1];
	Turtle.heading = r[4];
	if(r.length>5) Turtle.startseed = Turtle.seed = r[5];
}

Maker.addBlocks = function(records){
	for(var i=0;i<records.length;i++){
		var block = records[i];
		var type = block[0], label=block[3][0];
	//	type = equivalence(type);
		var special =  (type.indexOf("procedure")> -1) || (type.indexOf("start") > -1);
		if (!Defs.blockinfo[type] && !special) {
			Maker.error = "I don't know how to "+ type + ".\n Is this an old TurlteArt project?";
			console.log (Maker.error);
			return false;
		}
		var b= new Block(type);
		if(label!=undefined) b.setText(label);
		else if (b.basetype=='start') b.setText("");
		Maker.blocks.push(b);
	}
	return true;
}

Maker.connectBlocks = function(records){
	for(var i=0;i<records.length;i++){
		var block = Maker.blocks[i];
		var record = records[i];
		var you = Maker.blocks[record[4]];
		if (you==undefined) continue;
		var yourdock = record[5];
		block.connections[0] = you;
		you.connections[yourdock] = block;
	}
}

Maker.findProcs = function(blks){
	Runtime.procs = {};
	for(var b in blks) {
		if ((blks[b].basetype=='start') && blks[b].value) Runtime.procs[blks[b].value]=blks[b];
	}
}

Maker.findStartingBlock = function(){
	var blks = Maker.blocks.reverse();
	for(var i in blks){
		var b = blks[i];
		if(b.connections[0]!=undefined) continue;
		if(b.docks()[0][0]!='flow') continue;
		if((b.type=='clean')&&(b.connections[1]!=undefined)) return b;
		if(b.type=='fillscreen') return b;
	}
	for(var i in blks){
		var b = blks[i];
		if(b.connections[0]!=undefined) continue;
		if(b.docks()[0][0]!='flow') continue;
		if(b.type=='clean') continue;
		return b;
	}
}

//////////////
// Utils
//////////////
var eventDispatch = {};

function waituntil (waitcond, fcn){
	if (Maker.timeout != undefined) clearTimeout(Maker.timeout);
	Maker.timeout = undefined;
	if (waitcond()) Maker.timeout = setTimeout(function (){waituntil(waitcond, fcn)}, 500);
	else fcn();
}

function newHTML(type, c, p) {
	var e = document.createElement(type);
	if (c) e.setAttribute ("class", c);
	if (p) p.appendChild(e);
	return e;
}

function setCanvasSize(c, w, h){
	c.width = w;
	c.height = h;
	c.style.width = w+'px';
	c.style.height = h+'px';
}

function gn(str) {return document.getElementById(str);}
function now(){return new Date().getTime();}
function rl(){window.location.reload(true);}

function libInit(){
	isiPad = (window.orientation != undefined);
	frame = document.getElementById('frame');
	eventDispatch["start"] = isiPad ? "ontouchstart" : "onmousedown";
	eventDispatch["move"] = isiPad ? "ontouchmove" : "onmousemove";
	eventDispatch["end"] = isiPad ? "ontouchend" : "onmouseup";
}

function globalx(el){return el.getBoundingClientRect().left;}
function globaly(el){return el.getBoundingClientRect().top;}

function setProps(object, props){for(var i in props) object[i] = props[i];}
