const electron = require('electron')
const app = electron.app
const BrowserWindow = electron.BrowserWindow
const path = require('path')
const url = require('url')
const userDataPath = (electron.app || electron.remote.app).getPath('userData');
const fs = require('fs')
var appmenus;

var appDefaults = {
    windowBounds: { width: 800, height: 600 },
    processMode: "normal"
  }

var settings = appDefaults;
//configName: 'user-preferences',
let mainWindow;

function createWindow () {
  // Create the browser window.
  settings = getAppSettings();
  mainWindow = new BrowserWindow({
  	width: settings.width, 
  	height: settings.height, 
  	title: "TurtleArt PNG to SVG Converter",
   	show: false,
   	icon: path.join(__dirname, 'html5/assets/icons/png/64x64.png')})

  // and load the index.html of the app.
  mainWindow.loadURL(url.format({
    pathname: path.join(__dirname, 'index.html'),
    protocol: 'file:',
    slashes: true
  }))
  
	mainWindow.once('ready-to-show', () => {
  	mainWindow.show()
  	
	})
  // Open the DevTools.
  // mainWindow.webContents.openDevTools()

  // Emitted when the window is closed.
  mainWindow.on('closed', function () {
    mainWindow = null
  })
 
  mainWindow.on('resize', () => {
    let { width, height } = mainWindow.getBounds();
    changeSettings('windowBounds', { width, height });
  });

}

app.on('ready', function () {
	createWindow()
	appmenus = require('./mainmenus')
	appmenus.setMode(mainWindow,settings.processMode);
	})


// Quit when all windows are closed.
app.on('window-all-closed', function () {
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', function () {
  if (mainWindow === null) {
    createWindow()
  }
})

//////////////////////////
// Default preferences
/////////////////////////

function getAppSettings(){
 	var place = path.join(userDataPath, 'user-preferences.json');
 return parseDataFile(place, appDefaults);
//return appDefaults;
}

function parseDataFile(filePath, appDefaults) {
  try {
    return JSON.parse(fs.readFileSync(filePath));
  } catch(error) {
    return appDefaults;
  }
}

function changeSettings(key, state){
	settings[key] = state;
	var place = path.join(userDataPath, 'user-preferences.json');
	fs.writeFileSync(place, JSON.stringify(settings));
}

////////////////////////////
// External methods
///////////////////////////

exports.saveProject = (name, str) => {
	if (appmenus) appmenus.save(mainWindow, name, str);
}

exports.setUserPreference = (key, state) => {
	changeSettings(key, state);
}

exports.getUserPreference = (key) => {
	return settings[key] ? settings[key]  : appDefaults[key];
	changeSettings(key, state);
}